A Problem-Solving FlowChart || 如何解决编程问题

时间:2023-03-09 00:22:08
A Problem-Solving FlowChart || 如何解决编程问题

This is from book Cracking the coding interview, Gayle Laakmann Mcdowell. The flowchart can be used when you have a tech interview, coding contest or even make project. It reveals a creative way of thinking.

There are 7 steps.

1. Listen

2. Example

3. Brute Force

4. Optimize: BUD Optimization: Bottlenecks, Unnecessary works, Duplicated Work

5. Walk Through

6. Implement

7. Test

For detailed info, please refer the book

Give a high level summary on how to resolve algorithm puzzles. 

i. String, Array puzzles

Sorting

Some puzzles looks like hard, but it will be easier if you sort the array or string.

HashTable

Some puzzles can be resovled with brute-force with low efficiency. It will tremedously increase the efficiency with low space consume if HashTable be used, which is to map array or string to a alphabet[0]*26 array.

for Python programmer, the built-in data structure Dictionary is suible for making HashTable

Each key-value pair at Dict is seperated by colon(:), each pair eletment is seperated by comma(,), all Dict is included in {}, as follow shown:

d = {key1 : value1, key2 : value2 }

Key must be unique, value is not necessary

More detail:  http://www.runoob.com/python/python-dictionary.html

leetcode 387, 567

Double index

Some puzzles are easy but it will become hard if it require in-place operation. In this situation, double index will help resolve the puzzle. One index work ahead to traverse origin array while another index work behind to modify original array to generate target one.

leetcode 443, 48

Pay attention to index out bounds

Always pay heavy attention to index out bounds issue when using FOR LOOP, pay attention to edge condition of the FOR LOOP.

ii. Linked List

Multi-pointers

Kind like the the double index mentioned above, define multiple pointers to manipulate the linked list. Pay attention to the next pointer of nodes

Create an additional Head Node before Head

For some puzzle, in order to avoid different process on head node, usually create an additional Head Node before Head.

--------------------------------------我是分隔线--------------------下面是中文-----------------------

这个解题思路是Gayle Laakmann Mcdowell在她的书中 Cracking the coding interview说的.我们能在开发岗位技术面试,一些编程比赛,甚至在工作中都能用到这种思路.它给出了一种创造性思考的方式.

总共分七步.

1. 倾听

仔细听(如果是在面试中,面试管会口述问题),或者仔细看问题描述.包括一些细节比如数据的类型,输入数据的范围,一些约束条件等等

2. 举例子

当充分理解题目之后,可以画一些图或者举一些简单的例子来形象化问题.

3. 暴力穷举

先尽快用暴力穷举的方式相出解决方案,但是先不急着写代码.这是下一步优化的基础.

4. 优化

使用BUD原则来优化,B是指Bottlenecks,U是指Unnecessary Work,D是指Duplicated Work.

B具体来讲是找到算法中耗时最大的部分,然后对它优化,如果你优化的对象不是耗时最大的部分,那么即使能把这部分优化为O(1)的算法,整体上还是很慢.

U是指根据题目的描述,限制,有些计算是没有必要去做的,及时去掉这些无用功的计算.

D是指重复计算的部分,在动态规划中这个问题最明显.

5. 走一边

现在有了优化的算法了,在写代码之前脑海里或者纸上再过一遍算法

6. 写代码

目标是写漂亮的代码,可以模块化代码等让代码清晰,可读

7. 测试

首先进行算法上的测试,也就是用思路再走一遍代码,看有没有遗漏什么部分没?

接着对一些数学或者可能出现NULL的地方仔细检查下.

再是做small test cases,最后做special cases and edge cases.

下面就一些算法问题做个高度概括性的总结

i. 字符串,数组相关问题

排序

有些问题看起来很难解决,但是当对数组排序后,问题就好解决多了.

HashTable

有些问题用brute-force,效率很低,使用HashTable,把字符按照映射到字符数组alphabet[0]*26,能用较小的空间提高效率

对于使用python的程序员,在做HashTable的时候,要善于使用Python的特殊数据结构--“字典(Dictionary)”

字典的每个键值(key=>value)对用冒号(:)分割,每个对之间用逗号(,)分割,整个字典包括在花括号({})中 ,格式如下所示:

d = {key1 : value1, key2 : value2 }

键必须是唯一的,但值则不必。

值可以取任何数据类型,但键必须是不可变的,如字符串,数字或元组。

具体请参考 http://www.runoob.com/python/python-dictionary.html

leetcode 387, 567

双下标

有些问题需要做in-place的变化,可以使用双下标,一个下标走原始数组,一个下标跟在后边,修改原材数组成为新数组

leetcode 443, 48

注意下标越界

在做循环的时候,永远要留意边界是否越界

ii. 链表相关问题

多指针

有点像上面的双下标,按照问题要求可以多设几个指针,来进行对整个链表的操作,操作过程中注意next的指向。

Head前再加个Head Node

对有些问题,为了是head节点不需要特殊化处理,可以在head前面新建一个node,再进行操作。